<template functional>
  <div id="lectureListWrapper">
    <!-- 아이템 순서 변경안될 시 v-sortable 수정하기 -->
    <el-table
      :data="props.list"
      :row-style="listeners['tableColumnColor']"
      class="elTable-label"
      v-sortable="data.attrs.sortableOptions"
      :fit="true"
    >
      <div slot="empty">
        {{ parent.$t("STUDENT_MENU.NO_MADE_LEC") }}
      </div>
      <el-table-column
        prop="index"
        :label="parent.$t('LECTURE_LIST.NUMBER')"
        width="90"
        align="center"
      >
        <template slot-scope="scope">
          <!--
            <el-button icon="el-icon-arrow-up" v-if="props.type === 'TEACHER'"
              type="text" size="mini" @click="listeners['up'](scope.$index)"
            />
            -->
          {{ scope.$index + 1 }}
          <!--
            <el-button icon="el-icon-arrow-down" v-if="props.type === 'TEACHER'"
              type="text" size="mini" @click="listeners['down'](scope.$index)"
            />
            -->
        </template>
      </el-table-column>

      <el-table-column
        prop="type"
        :label="parent.$t('LECTURE_LIST.TYPE')"
        width="300"
        align="left"
      >
        <template slot-scope="scope">
          <span v-if="scope.row.type === '[유인]'">
            {{ parent.$t("LECTURE.TYPE_PRESENT") }}
          </span>
          <span v-else-if="scope.row.type === '[무인]개인'">
            {{ parent.$t("LECTURE.TYPE_INDI") }}
          </span>
          <span v-else-if="scope.row.type === '[무인]단체'">
            {{ parent.$t("LECTURE.TYPE_GROUP") }}
          </span>
          <span v-else-if="scope.row.type === '[소그룹방]'">
            {{ parent.$t("LECTURE.TYPE_DISC") }}            
          </span>
          <span v-else-if="scope.row.type === '[회의방]'">
            {{ parent.$t("LECTURE.TYPE_MEETING") }}            
          </span>
        </template>
      </el-table-column>      
      <template v-if="props.type === 'TEACHER'">
        <el-table-column
          prop="name"
          :label="parent.$t('LECTURE_LIST.LECTURE_NAME')"
          align="left"
        ></el-table-column>
        <el-table-column
          :label="parent.$t('TEACHER_CLASS.PERIOD')"
          width="230"
          align="left"
        >
          <template slot-scope="scope">
            <div v-if="scope.row.type !== '[유인]'">
              <div v-if="scope.row.type === '[무인]단체'">
                {{
                  scope.row.start_time
                    ? new Date(scope.row.start_time).toLocaleDateString("en-US") +
                      " / " +
                      new Date(scope.row.start_time).toLocaleTimeString("en-US")
                    : parent.$t("TEACHER_CLASS.UNDECIDED")
                }}
              </div>
              <div v-if="scope.row.type === '[무인]개인'">
                {{
                  scope.row.end_time
                    ? new Date(scope.row.start_time).toLocaleDateString("en-US")
                    : parent.$t("TEACHER_CLASS.UNDECIDED")
                }}
                ~
                {{
                  scope.row.end_time
                    ? new Date(scope.row.end_time).toLocaleDateString("en-US")
                    : parent.$t("TEACHER_CLASS.UNDECIDED")
                }}
              </div>
            </div>
          </template>
        </el-table-column>
        
        <!-- <el-table-column
            :label="parent.$t('LECTURE_LIST.PARTICIPANTS')"
            width="135"
            align="center"
          >
            <template slot-scope="scope">
              {{scope.row.student_number}} / {{ scope.row.capacity }}
            </template>
          </el-table-column> -->

        <!-- TODO
          <el-table-column
            label="수강 이해도(평균)"
            width="135"
             align="left"
          >
            <template slot-scope="scope">
              몇%
            </template>
          </el-table-column>
          -->
        <!-- 2021-04-07 유형이 [소그룹방]일 경우 회의방으로 바로 이동 -->
        <!-- 세션 유형을 [유인], [무인]단체, [무인]개인, [소그룹방], [소그룹방] 으로 나눈다 -->
        <!-- <el-table-column label="test">
          <template slot-scope="scope">
            <span>{{ scope.row.room_id }}</span>  
          </template>
        </el-table-column> -->
        <el-table-column label="-" width="120" align="center">
          <template slot-scope="scope">          
            <router-link v-if="scope.row.type === '[소그룹방]'" :to="`/a/SGroup/${scope.row.lecture_id}/${scope.row.class_id}`">
              <el-button
                class="LectureListTeachingButton"
                v-if="scope.row.type !== '[무인]개인'"
                >{{ parent.$t("LECTURE_LIST.START_LECTURE") }}</el-button
              >
            </router-link>
            <!-- 회의방으로 바로 들어가려면 lectureId를 가지고 소그룹방 ID를 찾을 수 있어야한다. -->
            <!-- lectureId로 small_meeting_rooms 테이블의 roomId를 가져와서 들어와야 한다-->
            <router-link v-if="scope.row.type === '[회의방]'" :to="`/a/SGroup/${scope.row.lecture_id}/${scope.row.class_id}/${scope.row.room_id}`">
              <el-button                
                class="LectureListTeachingButton"                
                v-if="scope.row.type !== '[무인]개인' && scope.row.type === '[회의방]'"              
                >{{ parent.$t("LECTURE_LIST.START_LECTURE") }}</el-button                
              >                 <!-- parent.$t("LECTURE_LIST.START_LECTURE") -->
            </router-link>
            <router-link v-if="scope.row.type !== '[소그룹방]' && scope.row.type !== '[회의방]'" :to="`/a/teacher/NNlecture/${scope.row.lecture_id}/live?classId=${scope.row.class_id}`">
              <el-button
                class="LectureListTeachingButton"
                v-if="scope.row.type !== '[무인]개인'"
                >{{ parent.$t("LECTURE_LIST.START_LECTURE") }}</el-button
              >
            </router-link>
          </template>
        </el-table-column>
        

        <el-table-column v-if="props.connectFlag" label="-" width="180" align="center">
          <template slot-scope="scope">
            <el-button
              class="LectureListActivaiteButton"
              @click="listeners['activaite'](scope.$index)"
              v-if="scope.row.valid"
              >{{ parent.$t("LECTURE_LIST.ACTIV_NEXT_SESSION") }}</el-button
            >
          </template>
        </el-table-column>

        <el-table-column v-if="!props.isPhone" label="-" width="100" align="center">
          <template slot-scope="scope">
            <router-link
              :to="`/a/teacher/NNlecture/${scope.row.lecture_id}/manage?classId=${scope.row.class_id}`"
            >
              <el-button class="edit-btn LectureListEditButton">{{
                parent.$t("LECTURE_LIST.EDIT")
              }}</el-button>
            </router-link>
          </template>
        </el-table-column>

        <el-table-column label="-" width="100" align="center">
          <template slot-scope="scope">
            <el-button
              class="LectureListDeleteButton"
              type="danger"
              @click="listeners['delete'](scope.$index)"
              >{{ parent.$t("LECTURE_LIST.DELETE") }}</el-button
            >
          </template>
        </el-table-column>
      </template>

      <template v-if="props.type === 'STUDENT' || props.type === 'STUDENT2'">
        <el-table-column
          prop="name"
          :label="parent.$t('STUDENT_MENU.LECTURE')"
          align="center"
        ></el-table-column>
        <el-table-column
          :label="parent.$t('STUDENT_MENU.ACTV_DUR')"
          width="300"
          align="center"
        >
          <template slot-scope="scope">
            <div v-if="scope.row.type !== '[유인]'">
              <div v-if="scope.row.type === '[무인]단체'">
                {{
                  scope.row.start_time
                    ? new Date(scope.row.start_time).toLocaleDateString("en-US") +
                      " / " +
                      new Date(scope.row.start_time).toLocaleTimeString("en-US")
                    : parent.$t("TEACHER_CLASS.UNDECIDED")
                }}
              </div>
              <div v-if="scope.row.type === '[무인]개인'">
                {{
                  scope.row.end_time
                    ? new Date(scope.row.start_time).toLocaleDateString("ko-KR")
                    : parent.$t("TEACHER_CLASS.UNDECIDED")
                }}
                ~
                {{
                  scope.row.end_time
                    ? new Date(scope.row.end_time).toLocaleDateString("ko-KR")
                    : parent.$t("TEACHER_CLASS.UNDECIDED")
                }}
              </div>
            </div>
          </template>
        </el-table-column>
        <!--el-table-column
            label="수강여부"
            width="100"
            align="center"
          >
            <template slot-scope="scope">
              {{ scope.row.heard }}
            </template>
          </el-table-column-->

        <!-- <el-table-column
            :label="parent.$t('LECTURE_LIST.PARTICIPANTS')"
            width="135"
            align="center"
            v-if="props.type === 'STUDENT'"
          >
            <template slot-scope="scope">
              {{scope.row.student_number}} / {{ scope.row.capacity }}
            </template>
          </el-table-column> -->
        
        <!-- 2021-04-13 세션 유형에 따라 다르게 동작 -->
        <el-table-column label="-" width="120" align="center" fixed="right">          
          <template slot-scope="scope">
            <router-link v-if="scope.row.type === '[소그룹방]'" :to="`/a/SGroup/${scope.row.lecture_id}/${scope.row.class_id}`">
              <el-button                
                v-if="scope.row.type !== '[무인]개인'"
                >{{ parent.$t("STUDENT_MENU.ENTER_LECTURE") }}</el-button
              >
            </router-link>
            <router-link v-if="scope.row.type === '[회의방]'" :to="`/a/SGroup/${scope.row.lecture_id}/${scope.row.class_id}/${scope.row.room_id}`">
              <el-button                
                class="LectureListTeachingButton"                
                v-if="scope.row.type !== '[무인]개인' && scope.row.type === '[회의방]'"              
                >{{ parent.$t("LECTURE_LIST.START_LECTURE") }}</el-button                
              > 
            </router-link>
            <el-button 
              v-if="scope.row.type !== '[소그룹방]' && scope.row.type !== '[회의방]'"
              @click="listeners['join'](scope.$index)">
              {{ parent.$t("STUDENT_MENU.ENTER_LECTURE") }}
            </el-button>
          </template>
        </el-table-column>
        
        <el-table-column
          :label="parent.$t('STUDENT_MENU.QUEST_BY_LEC')"
          width="160"
          align="center"
          v-if="props.type === 'STUDENT'"
          fixed="right"
        >
          <template slot-scope="scope">
            <!-- [회의방], [소그룹방] 일 경우 제출 버튼이 보이지 않아야한다. -->
            <el-button 
              v-if="scope.row.type !== '[소그룹방]' && scope.row.type !== '[회의방]'"
              @click="listeners['homework'](scope.$index)">{{
              parent.$t("STUDENT_MENU.SUBMIT")
            }}</el-button>
          </template>
        </el-table-column>
      </template>
    </el-table>
  </div>
</template>

<script>
import isArray from "lodash.isarray";
import lectureService from '../../services/lectureService';

export default {
  name: "LectureList",  
  async mounted() {
    const vm = this;
    await vm.getMyClassLists();
    await vm.getClass({
      type: "TEACHER",
      classId: vm.classId,
    });
  },
  props: {
    type: {
      type: String,
      required: true,
      validator(value) {
        const allowedTypeList = ["TEACHER", "STUDENT", "STUDENT2"];
        if (!allowedTypeList.includes(value)) {
          // eslint-disable-next-line no-console
          console.error(`prop "type" should be one of ${allowedTypeList}`);
          return false;
        }
        return true;
      },
    },
    list: {
      type: Array,
      required: true,
      validator(value) {
        if (!isArray(value)) {
          // eslint-disable-next-line no-console
          console.error('prop "list" should be type Array');
          return false;
        }
        if (value.length === 0) {
          return true;
        }
        const firstElement = value[0];
        const allowedKeyOfClassListItem = ["id"]; // TODO: improve this list
        const firstElementKeySet = new Set(Object.keys(firstElement));
        if (firstElementKeySet.size === 0) {
          throw new Error("ClassList empty element received.");
        }
        for (let i = 0; i < allowedKeyOfClassListItem; i += 1) {
          const expectedKey = allowedKeyOfClassListItem[i];
          if (!firstElementKeySet.has(expectedKey)) {
            // eslint-disable-next-line no-console
            console.error(`prop "list" should have \`${expectedKey}\``);
            return false;
          }
        }
        return true;
      },
    },
    isPhone: {
      type: null,
    },
    connectFlag: {
      type: null,
    }
  },
};
</script>

<style scoped>
#lectureListWrapper {
  display: flex;
  width: 100%;
}
#topLabel {
  display: flex;
  justify-content: space-between;
  align-items: center;
}
.top-label-btns-column {
  display: flex;
  justify-content: space-between;
}
.top-label-btn {
  font-size: 14px !important;
  padding: 12px 16px !important;
  margin: 12px !important;
  color: #fff !important;
}
.data-table .table-button {
  padding: 10px;
  border: 1px solid #4366ac !important;
}

/* MyRoomCommonStyle.css */
nav {
  min-width: 250px;
}
#labelName {
  display: flex;
}
.selected-lecture {
  opacity: 40%;
}
section {
  min-width: 800px;
  width: 100%;
  margin: 35px 15px 0 25px;
}
section > div {
  padding-top: 10px;
}
#topLabel {
  width: initial;
  display: flex;
  justify-content: space-between;
  align-items: center;
}

/* main.css */
body {
  margin: 0px;
}
nav {
  float: left;
  width: 250px;
  height: 100%;
  background: #4366ac;
  color: #fff;
}
#logo {
  padding: 20px 0 20px 0;
  text-align: center;
}
#logo > p {
  font-size: 25px;
  font-weight: bold;
  font-family: "Roboto", sans-serif;
}
#profile {
  padding: 20px;
}
#profile1 img {
  float: left;
  margin: 5px;
}
#profile1 > p {
  margin: 5px 0 5px 0;
}
#profile2 {
  text-align: right;
}
#profile2 > p {
  text-decoration: underline;
}
#profile2 p:nth-child(1) {
  float: left;
  margin: 0;
}
section {
  float: left;
}
</style>
